import { css, LitElement, html } from 'lit';
import { queryAssignedNodes } from 'lit/decorators.js';
import { defineElement } from '@umbraco-ui/uui-base/lib/registration';

var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};
class UUIKeyElement extends LitElement {
  _changeCase() {
    if (this.slotNodes !== null) {
      this.slotNodes.forEach((node) => {
        var _a;
        if (node.nodeName === "#text" && node.nodeValue)
          node.nodeValue = (_a = node.nodeValue) == null ? void 0 : _a.toLowerCase();
      });
    }
  }
  render() {
    return html`<slot @slotchange=${this._changeCase}></slot>`;
  }
}
UUIKeyElement.styles = [
  css`
      :host {
        background: var(--uui-interface-surface, #fff);
        border: 1px solid var(--uui-interface-border, #d8d7d9);
        font-family: inherit;
        font-size: var(--uui-size-4,12px);
        border-radius: 5px;
        margin: 0px 5px;
        padding: 5px 7px;
        box-sizing: border-box;
        -webkit-user-select: none;
           -moz-user-select: none;
            -ms-user-select: none;
                user-select: none;
      }
    `
];
__decorateClass([
  queryAssignedNodes()
], UUIKeyElement.prototype, "slotNodes", 2);

class UUIKeyboardShortcutElement extends LitElement {
  render() {
    return html`<slot></slot>`;
  }
}
UUIKeyboardShortcutElement.styles = [
  css`
      :host {
        display: inline-block;
        font-family: inherit;
        font-size: var(--uui-size-4,12px);
      }

      ::slotted(*:first-child)uui-key {
        margin-left: 0px;
      }

      ::slotted(*:last-child)uui-key {
        margin-right: 0px;
      }
    `
];

defineElement("uui-key", UUIKeyElement);
defineElement("uui-keyboard-shortcut", UUIKeyboardShortcutElement);
